import random
import time

def generate_array(size, array_type):
    """ Generate array of a certain type and size
    """

    if array_type == "sorted":
        return sorted([random.randint(0, 100) for x in range(size)])
    elif array_type == "nearly_sorted":
        a = sorted([random.randint(0, 100) for x in range(size)])
        for swaps in range(size // 1000):
            i = random.randint(0, size - 1)
            j = random.randint(0, size - 1)

            a[i], a[j] = a[j], a[i]

        return a

    elif array_type == "reversed":
        return sorted([random.randint(0, 100) for x in range(size)], reverse=True)
    else:
        return [random.randint(0, 100) for x in range(size)]


def print_times(algorithm, step, iters, array_type="random", runs=1):
    """ Get run times of sorting algorithms on different
        sizes of data
    """

    size = step
    for i in range(iters):
        times = 0
        for j in range(runs):
            array = generate_array(size, array_type)

            t1 = time.time()
            algorithm(array)
            t2 = time.time()

            times += t2 - t1

        print(size, round(times / runs, 2))
        size += step